const QLSPrefObserver = 
{
	observe: function(subject, topic, prefName)
	{
		if (topic == "nsPref:changed" && prefName == "general.useragent.locale")
		{
			if (typeof(CheckLocale) == 'function') CheckLocale();
		}
	}
};
const QLSSettingsObserver =
{
	observe: function(subject, topic, state)
	{
		if (topic == "qls-settings" && state == 'OK') ApplySettings();
	}
}
const QLS_ALL_LOCALES = "af-ZA#am-ET#ar-AE#ar-BH#ar-DZ#ar-EG#ar-IQ#ar-JO#ar-KW#ar-LB#ar-LY#ar-MA#ar-OM#ar-QA#ar-SA#ar-SY#ar-TN#ar-YE#arn-CL#as-IN#ast-ES#az-AZ-Cyrl#az-AZ-Latn#ba-RU#be-BY#ber-DZ#bg-BG#bn-IN#bo-BT#bo-CN#br-FR#bs-BA-Cyrl#bs-BA-Latn#ca-AD#ca-ES#ca-FR#co-FR#cs-CZ#cy-GB#da-DK#de-AT#de-CH#de-DE#de-LI#de-LU#div-MV#el-GR#en-AU#en-BZ#en-CA#en-CB#en-GB#en-IE#en-IN#en-JA#en-MY#en-NZ#en-PH#en-SG#en-TT#en-US#en-ZA#en-ZW#es-AR#es-BO#es-CL#es-CO#es-CR#es-DO#es-EC#es-ES#es-ES-ts#es-GT#es-HN#es-MX#es-NI#es-PA#es-PE#es-PR#es-PY#es-SV#es-UR#es-US#es-VE#et-EE#eu-ES#fa-IR#fi-FI#fil-PH#fo-FO#fr-BE#fr-CA#fr-CH#fr-FR#fr-LU#fr-MC#fur-IT#fy-NL#ga-IE#gbz-AF#gl-ES#gsw-FR#gu-IN#ha-NG-Latn#he-IL#hi-IN#hr-BA#hr-HR#hu-HU#hy-AM#id-ID#ii-CN#is-IS#it-CH#it-IT#iu-CA-Cans#iu-CA-Latn#ja-JP#ja-JP-mac#ka-GE#kh-KH#kk-KZ#kl-GL#km-KH#kn-IN#kok-IN#ko-KR#ky-KG#lb-LU#lo-LA#lt-LT#lv-LV#mi-NZ#mk-MK#ml-IN#mn-CN#mn-MN#moh-CA#mr-IN#ms-BN#ms-MY#mt-MT#nb-NO#ne-NP#nl-BE#nl-NL#nn-NO#ns-ZA#oc-FR#or-IN#pa-IN#pl-PL#ps-AF#pt-BR#pt-PT#qut-GT#quz-BO#quz-EC#quz-PE#rm-CH#ro-RO#ru-RU#rw-RW#sah-RU#sa-IN#se-FI#se-NO#se-SE#si-LK#sk-SK#sl-SI#sma-NO#sma-SE#smj-NO#smj-SE#smn-FI#sms-FI#sq-AL#sr-BA-Cyrl#sr-BA-Latn#sr-SP-Cyrl#sr-SP-Latn#sv-FI#sv-SE#sw-KE#syr-SY#ta-IN#te-IN#tg-TJ-Cyrl#th-TH#tk-TM#tn-ZA#tr-IN#tr-TR#tt-RU#ug-CN#uk-UA#ur-PK#uz-UZ-Cyrl#uz-UZ-Latn#vi-VN#wee-DE#wen-DE#wo-SN#xh-ZA#yo-NG#zh-CHS#zh-CHT#zh-CN#zh-HK#zh-MO#zh-SG#zh-TW#zu-ZA";
const QLS_DEFAULT_LOCALES = "en-US#nl-NL#fr-FR#it-IT#es-ES#ja-JP#de-DE#tr-TR#ko-KR#pl-PL#cs-CZ#bg-BG#pt-PT#sl-SI#zh-CN#sk-SK#ru-RU#fy-NL#zh-TW#pt-BR#da-DK#lt-LT#ja-JP-mac#gl-ES#sq-AL#he-IL#en-GB#fa-IR#km-KH#uk-UA#hr-HR#be-BY#el-GR#vi-VN#ro-RO#es-AR#hu-HU";

addEventListener("load",Init,true);

function Init()
{
	var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
	oPrefService.addObserver("general.useragent.locale", QLSPrefObserver, false);

	this.oPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("general.useragent.");
	this.oQLSPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.qls.");
	this.oALPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("intl.");
	this.oSCPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("spellchecker.");

	if (!this.oQLSPref.prefHasUserValue("notifyrestart")) this.oQLSPref.setBoolPref("notifyrestart", true);
	if (!this.oQLSPref.prefHasUserValue("askautorestart")) this.oQLSPref.setBoolPref("askautorestart", true);

	if (!this.oQLSPref.prefHasUserValue('locale')) SetQLSPref("locale", GetLocale());

	if (!this.oQLSPref.prefHasUserValue('customlocale1')) SetQLSPref("customlocale1", "");
	if (!this.oQLSPref.prefHasUserValue('customlabel1')) SetQLSPref("customlabel1", "");
	if (!this.oQLSPref.prefHasUserValue('customlocale2')) SetQLSPref("customlocale2", "");
	if (!this.oQLSPref.prefHasUserValue('customlabel2')) SetQLSPref("customlabel2", "");
	if (!this.oQLSPref.prefHasUserValue('customlocale3')) SetQLSPref("customlocale3", "");
	if (!this.oQLSPref.prefHasUserValue('customlabel3')) SetQLSPref("customlabel3", "");

	if (!this.oQLSPref.prefHasUserValue('visiblemenuitems')) SetQLSPref("visiblemenuitems", QLS_DEFAULT_LOCALES);

	if (!this.oQLSPref.prefHasUserValue('switch_gulocale')) SetQLSPrefBool("switch_gulocale", true);
	if (!this.oQLSPref.prefHasUserValue('switch_accept_languages')) SetQLSPrefBool("switch_accept_languages", true);
	if (!this.oQLSPref.prefHasUserValue('switch_dictionary')) SetQLSPrefBool("switch_dictionary", true);

	this.oDefPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
	this.sDefaultLocale = GetDefaultLocale();

	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.addObserver(QLSSettingsObserver, "qls-settings", false); 

	ApplySettings();
	InitDefault();
	CheckLocale();
}

function InitDefault()
{
	if (document.getElementById('taskPopup')) InitDefaultSeamonkey();
	var oMItem;
	var sLabel;

	oMItem = document.getElementById("defaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
	oMItem = document.getElementById("tbdefaultQLS");
	if (oMItem)
	{
		sLabel = oMItem.getAttribute('statustext') + " (" + this.sDefaultLocale +  ")";

		oMItem.setAttribute("label", sLabel);
		oMItem.setAttribute("ccode", this.sDefaultLocale);
	}
}

function CheckLocale()
{
	var sLocale = GetQLSPref("locale");
	var oElement = document.getElementById(sLocale);
	var oTBElement = document.getElementById('tb_' + sLocale);
	if (!oElement) oElement = document.getElementsByAttribute('ccode', sLocale.toLowerCase())[0];
	if (!oElement)
	{
		sLocale = GetSeamonkeyLocale()
		oElement = document.getElementById(sLocale);
		if (!oElement) oElement = document.getElementsByAttribute('ccode', sLocale.toLowerCase())[0];
	}
	if (oElement)
	{
		oElement.setAttribute("hidden", false);
		oElement.setAttribute("checked", true);
	}
	if (oTBElement)
	{
		oTBElement.setAttribute("hidden", false);
		oTBElement.setAttribute("checked", true);
	}
	if (document.getElementById("defaultQLS")) document.getElementById("defaultQLS").setAttribute('disabled', sLocale == this.sDefaultLocale);
	if (document.getElementById("tbdefaultQLS")) document.getElementById("tbdefaultQLS").setAttribute('disabled', sLocale == this.sDefaultLocale);
}

function ChangeLocale(sLocale)
{
	sLocale = sLocale.replace('tb_', '');
	if (GetQLSPref("locale") == sLocale) return;

	SetQLSPref("locale", sLocale)
	CheckLocale();
	
	if (GetQLSPrefBool("switch_accept_languages")) UpdateAcceptLanguages(sLocale);
	if (GetQLSPrefBool("switch_dictionary")) SwitchSpellCheckerDictionary(sLocale);
	
	if (GetQLSPrefBool("switch_gulocale"))
	{
		SetLocale(sLocale);
	
		if (document.getElementById('taskPopup')) ChangeLocaleSeamonkey(sLocale);
		DoLocaleWorkAround();
	}
}

function DoLocaleWorkAround()
{
	//Showing about:config seems to solve the problem of not being able to change non-installed locale (often) in Ff 1.0.7 and 1.4
	window.open("chrome://qls/content/qlsreloadchrome.xul", "qlspleasewait", "chrome,close,titlebar,modal,centerscreen"); 
	var oPromptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var checkResult = {};

	try
	{
		//Auto restart in Ff 1.4 and later.
		var oAppStartup = Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(Components.interfaces.nsIAppStartup);
		if (!oAppStartup.eRestart) throw("Restart is not supported in Seamonkey...");
		var bAskRestart = this.oQLSPref.getBoolPref("askautorestart");
		if (bAskRestart == true)
		{
			var sTitle = document.getElementById("mCavemanQLS").getAttribute('label');
			var sMsg = document.getElementById("msCavemanQLS2").getAttribute('statustext');
			var sNotify = document.getElementById("msCavemanQLS").getAttribute('statustext');

			var bRestart = oPromptService.confirmCheck(window,sTitle, sMsg, sNotify, checkResult);

			if (checkResult.value) this.oQLSPref.setBoolPref("askautorestart", false);
		}
		if (bRestart == true || bAskRestart == false) oAppStartup.quit(oAppStartup.eAttemptQuit | oAppStartup.eRestart);
	}
	catch (e)
	{
		var bNotify = this.oQLSPref.getBoolPref("notifyrestart")
	
		if (bNotify == true)
		{
			//Show message in other versions.
			if (document.getElementById("mCavemanQLS") && document.getElementById("mpCavemanQLS"))
			{
				var sTitle = document.getElementById("mCavemanQLS").getAttribute('label');
				var sMsg = document.getElementById("mpCavemanQLS").getAttribute('statustext');
				var sNotify = document.getElementById("msCavemanQLS").getAttribute('statustext');

				oPromptService.alertCheck(window, sTitle, sMsg, sNotify, checkResult);
				if (checkResult.value) this.oQLSPref.setBoolPref("notifyrestart", false);
			}
		}
	}
}

function ChangeLocaleSeamonkey(sLocale)
{
	var QLS_InProfile = true;
	
	var oRDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
	try {var oDS = oRDF.GetDataSourceBlocking("rdf:chrome");}
	catch (e) {return;}

	var inProfile = oDS.GetTarget(oRDF.GetResource("urn:mozilla:package:qls"), oRDF.GetResource("http://www.mozilla.org/rdf/chrome#locType"), true);
	if (inProfile instanceof Components.interfaces.nsIRDFLiteral && inProfile.Value == "install") QLS_InProfile = false;
	
	try
	{
		var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
		if (!("selectLocaleForPackage" in chromeRegistry)) chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistrySea);
		chromeRegistry.selectLocaleForPackage(sLocale, "qls", QLS_InProfile);
	}
	catch (e) {return;}
}

function InitDefaultSeamonkey()
{
	if (this.sDefaultLocale.length > 10)
	{
		var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
		this.sDefaultLocale = chromeRegistry.getSelectedLocale("global");

		if (("selectLocaleForPackage" in chromeRegistry))
		{
			var QLS_InProfile = true;
			var oRDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			try {var oDS = oRDF.GetDataSourceBlocking("rdf:chrome");}
			catch (e) {return;}

			var inProfile = oDS.GetTarget(oRDF.GetResource("urn:mozilla:package:mozgest"), oRDF.GetResource("http://www.mozilla.org/rdf/chrome#locType"), true);
			if (inProfile instanceof Components.interfaces.nsIRDFLiteral && inProfile.Value == "install") QLS_InProfile = false;
			var QLSLocale = chromeRegistry.getSelectedLocale("qls");
			chromeRegistry.selectLocaleForPackage(QLSLocale, "qls", QLS_InProfile);	
		}		
	}
}

function OpenSettings()
{
	window.open("chrome://qls/content/qlssettings.xul", "qls-settings", "centerscreen,chrome,width=700,height=450,resizable");
}

function ApplySettings()
{
	var oMItem, oTBMItem;
	var sLabel = "", sLocale = "";
	var bShowSep = false;
	
	oMItem = document.getElementById("qlscustom1");
	oTBMItem = document.getElementById("tbqlscustom1");
	sLocale = GetQLSPref("customlocale1");
	sLabel = GetQLSPref("customlabel1");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
	}
	oMItem = document.getElementById("qlscustom2");
	oTBMItem = document.getElementById("tbqlscustom2");
	sLocale = GetQLSPref("customlocale2");
	sLabel = GetQLSPref("customlabel2");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
	}
	oMItem = document.getElementById("qlscustom3");
	oTBMItem = document.getElementById("tbqlscustom3");
	sLocale = GetQLSPref("customlocale3");
	sLabel = GetQLSPref("customlabel3");
	if (sLocale != "" && sLabel != "" && oMItem)
	{
		oMItem.setAttribute("hidden", false);
		oMItem.setAttribute("clocale", sLocale);
		oMItem.setAttribute("ccode", sLocale.toLowerCase());
		oMItem.setAttribute("label", sLabel);
		bShowSep = true;
		if (oTBMItem)
		{
			oTBMItem.setAttribute("hidden", false);
			oTBMItem.setAttribute("clocale", sLocale);
			oTBMItem.setAttribute("ccode", sLocale.toLowerCase());
			oTBMItem.setAttribute("label", sLabel);
		}
	}
	
	if (bShowSep == true) document.getElementById("msCavemanQLS2").setAttribute("hidden", false);
	
	var aAllMItems = QLS_ALL_LOCALES.split("#");
	var aMItems = GetQLSPref("visiblemenuitems").split("#");
	var iIndex, iLen;
	
	iLen = aAllMItems.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oMItem = document.getElementById(aAllMItems[iIndex]);
		if (oMItem && oMItem.getAttribute("checked") == false) oMItem.setAttribute("hidden", true);
		oTBMItem = document.getElementById('tb_' + aAllMItems[iIndex]);
		if (oTBMItem && oTBMItem.getAttribute("checked") == false) oTBMItem.setAttribute("hidden", true);
	}
	iLen = aMItems.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oMItem = document.getElementById(aMItems[iIndex]);
		if (oMItem) oMItem.setAttribute("hidden", false);
		oTBMItem = document.getElementById('tb_' + aMItems[iIndex]);
		if (oTBMItem) oTBMItem.setAttribute("hidden", false);
	}
}

function GetLocale()
{
	try {return this.oPref.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oPref.getCharPref("locale");
}

function GetDefaultLocale()
{
	try {return this.oDefPref.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oDefPref.getCharPref("locale");
}

function GetSeamonkeyLocale()
{
	var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
	return chromeRegistry.getSelectedLocale("qls");
}

function SetLocale(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oPref.setComplexValue("locale", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function UpdateAcceptLanguages(sData)
{
	var sAL = GetAcceptLanguages();
	var aAL = sAL.split(',');
	var sSearch = sData;
	var iIndex = ArrayIndexOf(aAL, sSearch);
	sSearch = GetCCode(sSearch);
	if (iIndex == -1) iIndex = ArrayIndexOf(aAL, sSearch);

	//Remove lang code from the accept languages.
	while (iIndex >= 0)
	{	
		aAL.splice(iIndex, 1);
		iIndex = ArrayIndexOf(aAL, sSearch);
		if (iIndex == -1)
		{
			sSearch = GetCCode(sSearch);
			iIndex = ArrayIndexOf(aAL, sSearch);
		}
	}
	//Add it at the beginning again, most detailed must come first.
	if (sData.length > sSearch)
	{
		aAL.unshift(sData);
		if (sSearch!= sData) aAL.unshift(sSearch);
	}
	else
	{
		aAL.unshift(sSearch);
		if (sData != sSearch) aAL.unshift(sData);
	}
	sAL = aAL.join(',');
	SetAcceptLanguages(sAL);
}

function SwitchSpellCheckerDictionary(sData)
{
	try
	{
		var oSC = Components.classes['@mozilla.org/spellchecker/myspell;1'].getService(Components.interfaces.mozISpellCheckingEngine);
		var aDictionaries  = {};
		var aCount = {};
		var aLocales;
		var iIndex;

		oSC.getDictionaryList(aDictionaries, aCount);
		aLocales = aDictionaries.value;
		iIndex = ArrayIndexOf(aLocales, sData)
		if (iIndex == -1)
		{
			//Long lang code does not exist, try short one.
			sData = GetCCode(sData);
			iIndex = ArrayIndexOf(aLocales, sData);
		}
		if (iIndex >= 0)
		{
			//Only set if the locale is available cause it will break spell checking if you set a not installed dict.
			SetSpellCheckerDictionary(sData);
		}
	}
	catch (e) {/*No SpellChecker app.*/}
}

function GetAcceptLanguages()
{
	try {return this.oALPref.getComplexValue("accept_languages", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oALPref.getCharPref("accept_languages");
}

function SetAcceptLanguages(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oALPref.setComplexValue("accept_languages", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetSpellCheckerDictionary()
{
	try {return this.oSCPref.getComplexValue("dictionary", Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oSCPref.getCharPref("dictionary");
}

function SetSpellCheckerDictionary(sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oSCPref.setComplexValue("dictionary", Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetQLSPref(sName)
{
	try {return this.oQLSPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {}
	return this.oQLSPref.getCharPref(sName);
}

function SetQLSPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oQLSPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetQLSPrefBool(sName)
{
	return this.oQLSPref.getBoolPref(sName);
}

function SetQLSPrefBool(sName, bData)
{
	this.oQLSPref.setBoolPref(sName, bData);
}

function ArrayIndexOf(a, s)
{
	var iIndex = -1, iLen = a.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++) if (a[iIndex] == s) return iIndex;
	return -1;
}

function GetCCode(sData)
{
	var iIndex = sData.search('-');
	if (iIndex >= 0) return sData.substring(0, iIndex);
	return sData;
}
