//Modify QLS settings.
function InitWindow()
{
	this.sizeToContent();

	this.oQLSPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.qls.");

	var osbService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
   	this.oStringBundle = osbService.createBundle("chrome://qls/locale/qls.properties");

	this.oCustomLocale1 = document.getElementById('qlslocale1');
	this.oCustomLabel1 = document.getElementById('qlslabel1');
	this.oCustomLocale2 = document.getElementById('qlslocale2');
	this.oCustomLabel2 = document.getElementById('qlslabel2');
	this.oCustomLocale3 = document.getElementById('qlslocale3');
	this.oCustomLabel3 = document.getElementById('qlslabel3');
	
	this.oCustomLocale1.value = GetPref("customlocale1");
	this.oCustomLabel1.value = GetPref("customlabel1");
	this.oCustomLocale2.value = GetPref("customlocale2");
	this.oCustomLabel2.value = GetPref("customlabel2");
	this.oCustomLocale3.value = GetPref("customlocale3");
	this.oCustomLabel3.value = GetPref("customlabel3");
	
	if (GetPref("visiblemenuitems") != "")
	{
		var aMItems = GetPref("visiblemenuitems").split("#");
		var iIndex, iLen;
		
		if (aMItems && aMItems.length > 0)
		{
			iLen = aMItems.length;
			for (iIndex = 0; iIndex < iLen; iIndex ++)
			{
				document.getElementById(aMItems[iIndex]).setAttribute("checked", true);
			}
		}
	}

	this.oSwitchGULocale = document.getElementById('switch_gulocale');
	this.oSwitchGULocale.checked = GetPrefBool("switch_gulocale");
	this.oSwitchAcceptLanguages = document.getElementById('switch_accept_languages');
	this.oSwitchAcceptLanguages.checked = GetPrefBool("switch_accept_languages");
	this.oSwitchDictionary = document.getElementById('switch_dictionary');
	this.oSwitchDictionary.checked = GetPrefBool("switch_dictionary");

	this.oAskAutoRestart = document.getElementById('askautorestart');
	this.oAskAutoRestart.checked = GetPrefBool("askautorestart");

	InitRootLocales();
	this.oCustomLocale1.focus();
}

function InitRootLocales()
{
	var oItems = document.getElementsByAttribute('rootlocale', 'true');
	var iIndex, iLen = oItems.length;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (oItems[iIndex].getAttribute('haschildren') == "true") oItems[iIndex].setAttribute('label', GetString('qls.family.selectall', oItems[iIndex].getAttribute('ccode')))
	}
}

function CheckLanguageFamily(oLBItem)
{
	if (oLBItem.getAttribute('haschildren') == "true")
	{
		var oItems = document.getElementsByAttribute('ccode', oLBItem.getAttribute('ccode'));
		var iIndex, iLen = oItems.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			oItems[iIndex].checked = oLBItem.checked;
		}
	}
}

function ApplyAndClose()
{
	SetPref("customlocale1", this.oCustomLocale1.value);
	SetPref("customlabel1", this.oCustomLabel1.value);
	SetPref("customlocale2", this.oCustomLocale2.value);
	SetPref("customlabel2", this.oCustomLabel2.value);
	SetPref("customlocale3", this.oCustomLocale3.value);
	SetPref("customlabel3", this.oCustomLabel3.value);

	SetPrefBool("switch_gulocale", this.oSwitchGULocale.checked);
	SetPrefBool("switch_accept_languages", this.oSwitchAcceptLanguages.checked);
	SetPrefBool("switch_dictionary", this.oSwitchDictionary.checked);

	SetPrefBool("askautorestart", this.oAskAutoRestart.checked);

	var oLB = document.getElementById("lbvisiblemenuitems");
    var aItems = new Array();
	var iIndex, iLen;

	iLen = oLB.getRowCount();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (oLB.getItemAtIndex(iIndex).getAttribute("checked") == "true") //string for some strange reason...
		{
			aItems[aItems.length] = oLB.getItemAtIndex(iIndex).getAttribute("id");
		}
	}
	if (aItems.length > 0 || ((this.oCustomLocale1.value != "" && this.oCustomLabel1.value != "") || (this.oCustomLocale2.value != "" && this.oCustomLabel2.value != "") || (this.oCustomLocale3.value != "" && this.oCustomLabel3.value != "")))
	{
		SetPref("visiblemenuitems", aItems.join("#"));

		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "qls-settings", "OK");
		window.close();
	}
}

function SelectAllItems(bSelect)
{
	var oList = document.getElementById('lbvisiblemenuitems');
	var iIndex, iLen;
	
	iLen = oList.getRowCount();
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oList.getItemAtIndex(iIndex).setAttribute("checked", bSelect);
	}
}

function CollapseExpandAllItems(bExpand)
{
	document.getElementById('lbvisiblemenuitems').style.diplay = "none"
	var oItems = document.getElementsByAttribute('haschildren', 'true');
	var oChildren;
	var sDisplay = "-moz-grid-line";
	if (!bExpand) sDisplay = "none";
	var iIndex, iLen = oItems.length;
	var iCIndex, iCLen;
	
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oChildren = document.getElementsByAttribute('ccode', oItems[iIndex].getAttribute('ccode'));
		iCLen = oChildren.length;
		for (iCIndex = 0; iCIndex < iCLen; iCIndex ++)
		{
			if (!oChildren[iCIndex].getAttribute('haschildren'))
			{
				oChildren[iCIndex].style.display = sDisplay;
			}
		}
	
	}
	document.getElementById('lbvisiblemenuitems').style.diplay = "-moz-grid"
}

function GetPref(sName)
{
	try {return this.oQLSPref.getComplexValue(sName, Components.interfaces.nsIPrefLocalizedString).data;}
	catch (e) {alert(e);}
	return this.oQLSPref.getCharPref(sName);
}

function SetPref(sName, sData)
{
	var oPLS = Components.classes["@mozilla.org/pref-localizedstring;1"].createInstance(Components.interfaces.nsIPrefLocalizedString);
	oPLS.data = sData;
	this.oQLSPref.setComplexValue(sName, Components.interfaces.nsIPrefLocalizedString, oPLS);
}

function GetPrefBool(sName)
{
	return this.oQLSPref.getBoolPref(sName);
}

function SetPrefBool(sName, bData)
{
	this.oQLSPref.setBoolPref(sName, bData);
}

function GetString(sName, sVar1, sVar2)
{
	var sResult = "";
	if(this.oStringBundle)
	{
		sResult  = this.oStringBundle.GetStringFromName(sName);
		if (sVar1) sResult = sResult.replace(/%1/g, sVar1);
		if (sVar2) sResult = sResult.replace(/%2/g, sVar2);
	}
	return sResult;
}    	

